const jwt = require("jsonwebtoken")

module.exports = async (req, res, next) => {
    const authHeader = req.headers['authorization']
    const token = authHeader && authHeader.split(' ')[1]

    if(token === null) { return res.sendStatus(401) }
    jwt.verify(token, process.env.JWT_TOKEN, (err, user) => {
        if(err) return res.sendStatus(401)

        req.context = user
        next()
    })
    
}
