module.exports = async (req, res, functionName) => {
    const context = {
        params: req.params,
        query: req.query,
        body: req.body,
        userContext: req.context
    }
    const { code, message, data, type } = await functionName(context)
    if(type === 'html') {
        res.writeHeader(code, {"Content-Type": "text/html"})
        res.write(data)
        res.end()
        return res
    }
    return res.status(code).send({
        code,
        message,
        data
    })
}
