const ws = require('ws')

class WebSocket {
    constructor({ host, service_token }) {
        this.host = host
        this.service_token = service_token
    }

    connect() {
        try {
            const { host, service_token } = this;
            return new Promise(function(resolve, reject) {
                var server = new ws(host, service_token);
                server.onopen = function() {
                    // console.log('Websocket is connected to host : ' + host)
                    resolve(server);
                };
                server.onerror = function(err) {
                    throw new Error(`FAILED_CONNETING_WS[1] host ${host} : `,err)
                };
            });
        } catch (err) {
            throw new Error("FAILED_CONNETING_WS[2] : ",err)
        }
    }

    async sendMessage(data) {
        try {
            const connection = await this.connect()
            await connection.send(JSON.stringify(data))
            await connection.close()
            return true
    
        } catch (err) {
            throw new Error(err)
        }
    }

}

module.exports = WebSocket